local MinimapBtn = CreateFrame('Button', nil, Minimap)

-- Quand l'addon est chargé
local function onEvent(self, event, addOnName)
    TotalValueDB = TotalValueDB or {}
    TotalValueDB.isShowing = 0
    TotalValueDB.addonLoadedCount = (TotalValueDB.addonLoadedCount or 0) + 1
    -- Seulement si c'est la premiere fois qu'il est chargé
    if TotalValueDB.addonLoadedCount == 1 then
        TotalValueDB.minimapPosition = 0
        TotalValueDB.isShowing = 0
    end

    -- Emplacement du bouton sur la mini map
    Angle = TotalValueDB.minimapPosition
    -- local angle_init = TotalValueDB.minimapPosition
    local xPos_init = 80 * cos(Angle)
    local yPos_init = 80 * sin(Angle)
    xGoTo_miniMap = xPos_init
    yGoTo_miniMap = yPos_init
    moveMinimapBtn(TotalValueDB.minimapPosition)

end

function MinimapBtn:Load()
    -- Le bouton
    self:SetFrameStrata('HIGH')
    self:SetWidth(31)
    self:SetHeight(31)
    self:SetFrameLevel(8)
    self:RegisterForClicks('anyUp')
    self:SetHighlightTexture('Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight')

    -- Bordure
    local overlay = self:CreateTexture(nil, 'OVERLAY')
    overlay:SetWidth(53)
    overlay:SetHeight(53)
    overlay:SetTexture('Interface\\Minimap\\MiniMap-TrackingBorder')
    overlay:SetPoint('TOPLEFT')

    -- Icon personnalisé
    local icon = self:CreateTexture(nil, 'BACKGROUND')
    icon:SetWidth(20)
    icon:SetHeight(20)
    icon:SetTexture("Interface\\Addons\\TotalValue_TBC\\tval.tga")
    icon:SetPoint('CENTER')
    self.icon = icon

    -- Script
    self:SetScript('OnClick', self.OnClick)
    self:SetScript("OnMouseDown", self.OnMouseDown)
    self:RegisterForDrag("LeftButton")
    self:SetScript("OnDragStart", self.OnDragStart)
    self:SetScript("OnDragStop", self.OnDragStop)

    -- Position du bouton
    self:SetPoint("TOPLEFT", Minimap, "TOPLEFT", xGoTo_miniMap, yGoTo_miniMap)

end

function MinimapBtn:OnClick(button)
    if button == 'LeftButton' then
        if TotalValueLoaded == 0 then
            StartTotalValue()
        end
        if (TotalValueDB.isShowing == 0) then
            UIOHMoney:SetPoint("CENTER", correspondingX, correspondingY);
            UIOHMoney:Show();
            TotalValueDB.isShowing = 1
        else
            UIOHMoney:Hide()
            UIOHMoney:SetParent(nil)
            TotalValueDB.isShowing = 0
        end
    end
end

function UpdatePosTotalValueDB(x, y)
    theta = math.deg(math.atan2(y, x))
    TotalValueDB.minimapPosition = theta
end

function MinimapBtn:Move()
    local Angle = TotalValueDB.minimapPosition or 0
    local xpos = 80 * cos(Angle)
    local ypos = 80 * sin(Angle)
    MinimapBtn:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 52 - xpos, ypos - 52)
    UpdatePosTotalValueDB(xpos, ypos)
end

function MinimapBtn:OnUpdate()
    local xpos, ypos = GetCursorPosition()
    local xmin, ymin = Minimap:GetLeft(), Minimap:GetBottom()
    xpos = xmin - xpos / Minimap:GetEffectiveScale() + 70
    ypos = ypos / Minimap:GetEffectiveScale() - ymin - 70

    TotalValueDB.minimapPosition = math.deg(math.atan2(ypos, xpos))
    MinimapBtn:Move()
end

function MinimapBtn:OnDragStart()
    self:SetScript("OnUpdate", MinimapBtn.OnUpdate)
end

function MinimapBtn:OnDragStop()
    self:SetScript("OnUpdate", nil)
end

function moveMinimapBtn(Angle)
    local xpos = 80 * cos(Angle)
    local ypos = 80 * sin(Angle)
    MinimapBtn:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 52 - xpos, ypos - 52)
end

local ghostFrame = CreateFrame("Frame")
ghostFrame:RegisterEvent("ADDON_LOADED")
ghostFrame:SetScript("OnEvent", onEvent)

MinimapBtn:Load()
